\section{Evaluation}
\label{sec:evaluation}

The development of this project took more than 70 hours (not counting the time
spent writing the documentation). C++ power comes at a price: it is
unforgiving. Fortunately, the C++ standard provides very good abstractions for
most of the complex tasks. Being aware of which of this abstractions should be
used in each case and how to do it is the entry barrier to C++. From the
learning point of view, the project was a success.

From the implementation point of view, we accomplished
\href{\repo/-/raw/main/Abstract.pdf}{the proposal given at te beginning of the
semester}. Although, as with every project, we wish we had achieved more.

\begin{figure*}
    \centering
    \includegraphics[width=\textwidth]{\subdir/app.jpg}
    \caption{Application processing one of the test video files.}
    \label{fig:result}
\end{figure*}

We have made use
\href{https://gitlab.kitware.com/cmake/community/-/wikis/doc/ctest/Testing-With-CTest}{CTest}
to test each feature individually. This test suite has been very useful during
the development of the project and has been used to find and correct many bugs.

Unfortunately these tests also prove that our implementation is still very
prone to bugs. Therefore even if we accomplished the proposal given at the
beginning of the semester, the performance of the application is below our
expectations.

\begin{figure}
    \centering
    \includegraphics[width=.45\textwidth]{\subdir/app-mfcc.jpg}
    \caption{Application responsive to resizing of the window}
    \label{fig:processors}
\end{figure}